summaryrefslogtreecommitdiffstats
path: root/scripts
diff options
context:
space:
mode:
authorJeff Dike <jdike@x86_64.user-mode-linux.org>2010-08-05 12:31:01 -0400
committerRichard Purdie <rpurdie@linux.intel.com>2010-08-20 16:20:10 +0100
commit6ea1ed5f7b51b7c04e8aca29319c970846ddf1b8 (patch)
tree11577d6dc4afe7939489128e96b83e02f5e191f9 /scripts
parentf35a8d4079777453a2b60b7df5524b217260d252 (diff)
downloadpoky-6ea1ed5f7b51b7c04e8aca29319c970846ddf1b8.tar.gz
poky-qemu-[ifup|ifdown]: Use native tunctl
poky-qemu-ifup can run standalone by root in order to configure a bank of tap devices for later qemu use. These devices will, if possible, be owned by a specified group to which qemu users must belong. If the kernel is too old to support TUNSETGROUP, then it falls back to setting the tap device to be owned by a particular user, and that user will be the only one allowed to use it. Also overall usability improvements to the scripts, usage() help, etc. Signed-off-by: Jeff Dike <jdike@linux.intel.com> Signed-off-by: Scott Garman <scott.a.garman@intel.com>
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/poky-qemu-ifdown34
-rwxr-xr-xscripts/poky-qemu-ifup86
2 files changed, 101 insertions, 19 deletions
diff --git a/scripts/poky-qemu-ifdown b/scripts/poky-qemu-ifdown
index d9e9e95861..93a87559af 100755
--- a/scripts/poky-qemu-ifdown
+++ b/scripts/poky-qemu-ifdown
@@ -1,8 +1,8 @@
1#!/bin/sh 1#!/bin/bash
2 2#
3# QEMU network interface configuration script 3# QEMU network interface configuration script.
4# 4#
5# Copyright (C) 2006-2007 OpenedHand Ltd. 5# Copyright (c) 2006-2010 Intel Corp.
6# 6#
7# This program is free software; you can redistribute it and/or modify 7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version 2 as 8# it under the terms of the GNU General Public License version 2 as
@@ -10,16 +10,36 @@
10# 10#
11# This program is distributed in the hope that it will be useful, 11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of 12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details. 14# GNU General Public License for more details.
15# 15#
16# You should have received a copy of the GNU General Public License along 16# You should have received a copy of the GNU General Public License along
17# with this program; if not, write to the Free Software Foundation, Inc., 17# with this program; if not, write to the Free Software Foundation, Inc.,
18# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. 18# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
19 19
20usage() {
21 echo "$0 <tap-dev> <native-sysroot-basedir>"
22}
23
24if [ $# -ne 2 ]; then
25 usage
26 exit 1
27fi
28
20TAP=$1 29TAP=$1
30NATIVE_SYSROOT_DIR=$2
31
32TUNCTL=$NATIVE_SYSROOT_DIR/usr/bin/tunctl
33if [ ! -e "$TUNCTL" ]; then
34 echo "Error: Unable to find tunctl binary in '$NATIVE_SYSROOT_DIR/usr/bin'"
35
36 if [[ "$NATIVE_SYSROOT_DIR" =~ ^\/opt\/poky ]]; then
37 echo "This shouldn't happen - something is wrong with your toolchain installation"
38 else
39 echo "Have you run 'bitbake qemu-helper-native'?"
40 fi
21 41
22TUNCTL=`which tunctl` 42 exit 1
23[ "$TUNCTL" = "" ] && TUNCTL=/usr/sbin/tunctl 43fi
24 44
25$TUNCTL -d $TAP 45$TUNCTL -d $TAP
diff --git a/scripts/poky-qemu-ifup b/scripts/poky-qemu-ifup
index 3b2ed7c04a..68d8d37475 100755
--- a/scripts/poky-qemu-ifup
+++ b/scripts/poky-qemu-ifup
@@ -1,8 +1,21 @@
1#!/bin/sh 1#!/bin/bash
2 2#
3# QEMU network interface configuration script 3# QEMU network interface configuration script. This utility needs to
4# be run as root, and will use the tunctl binary from a Poky sysroot.
5# Note: many Linux distros these days still use an older version of
6# tunctl which does not support the group permissions option, hence
7# the need to use Poky's version.
8#
9# If this script is being run standalone in order to set up a bank of tap
10# devices for later qemu use, then a group id must be the first argument.
11# The resulting tap device will be group-owned by this group, and qemu
12# users must be members of this group.
4# 13#
5# Copyright (C) 2006-2007 OpenedHand Ltd. 14# If the kernel is too old to support TUNSETGROUP, then a user must be passed
15# in as the second argument, the tap device will be owned by that user, and
16# only that user will be able to use it.
17#
18# Copyright (c) 2006-2010 Intel Corp.
6# 19#
7# This program is free software; you can redistribute it and/or modify 20# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version 2 as 21# it under the terms of the GNU General Public License version 2 as
@@ -10,24 +23,73 @@
10# 23#
11# This program is distributed in the hope that it will be useful, 24# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of 25# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 26# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details. 27# GNU General Public License for more details.
15# 28#
16# You should have received a copy of the GNU General Public License along 29# You should have received a copy of the GNU General Public License along
17# with this program; if not, write to the Free Software Foundation, Inc., 30# with this program; if not, write to the Free Software Foundation, Inc.,
18# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. 31# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
19 32
20USER=$1 33usage() {
34 echo "$0 <gid> {uid} <native-sysroot-basedir>"
35 echo "Where uid is *only* included if this script complains when it's missing"
36}
37
38if [[ $# -lt 2 || $# -gt 3 ]]; then
39 usage
40 exit 1
41fi
42
43USER=""
44GROUP="-g $1"
45if [ $# -eq 2 ]; then
46 NATIVE_SYSROOT_DIR=$2
47else
48 USER=$2
49 NATIVE_SYSROOT_DIR=$3
50fi
51
52TUNCTL=$NATIVE_SYSROOT_DIR/usr/bin/tunctl
53if [ ! -e "$TUNCTL" ]; then
54 echo "Error: Unable to find tunctl binary in '$NATIVE_SYSROOT_DIR/usr/bin'"
21 55
22TUNCTL=`which tunctl` 56 if [[ "$NATIVE_SYSROOT_DIR" =~ ^\/opt\/poky ]]; then
23[ "$TUNCTL" = "" ] && TUNCTL=/usr/sbin/tunctl 57 echo "This shouldn't happen - something is wrong with your toolchain installation"
58 else
59 echo "Have you run 'bitbake qemu-helper-native'?"
60 fi
61
62 exit 1
63fi
24 64
25TAP=`$TUNCTL -b -u $USER` 65TAP=`$TUNCTL -b $GROUP 2>&1`
66STATUS=$?
67if [[ "$TAP" =~ "TUNSETGROUP" ]]; then
68 # TUNSETGROUP failed because of permissions or the kernel being too old
69 # Retry, falling back to a specific user
70 if [ "$USER" = "" ]; then
71 echo "TUNSETGROUP failed - add a username to the command line in order"
72 echo "to have the tap device owned by that user"
73 exit 1
74 fi
75 TAP=`$TUNCTL -b -u $USER 2>&1`
76 STATUS=$?
77 # Force this to appear on stderr in order that the user sees it if this
78 # is running from poky-qemu-internal and in order to avoid having this
79 # output confuse it.
80 echo "Only user $USER will be able to use $TAP - upgrade the kernel to " 1>&2
81 echo "2.6.23 or later in order to allow group access to tap devices" 1>&2
82fi
83if [ $STATUS -ne 0 ]; then
84 echo "tunctl failed:"
85 echo $TAP
86 exit 1
87fi
26 88
27IFCONFIG=`which ifconfig` 89IFCONFIG=`which ifconfig`
28if [ "x$IFCONFIG" = "x" ]; then 90if [ "x$IFCONFIG" = "x" ]; then
29 # better than nothing... 91 # better than nothing...
30 IFCONFIG=/sbin/ifconfig 92 IFCONFIG=/sbin/ifconfig
31fi 93fi
32 94
33n=$[ `echo $TAP | sed 's/tap//'` + 1 ] 95n=$[ `echo $TAP | sed 's/tap//'` + 1 ]
@@ -36,7 +98,7 @@ $IFCONFIG $TAP 192.168.7.$n
36# setup NAT for tap0 interface to have internet access in QEMU 98# setup NAT for tap0 interface to have internet access in QEMU
37IPTABLES=`which iptables` 99IPTABLES=`which iptables`
38if [ "x$IPTABLES" = "x" ]; then 100if [ "x$IPTABLES" = "x" ]; then
39 IPTABLES=/sbin/iptables 101 IPTABLES=/sbin/iptables
40fi 102fi
41 103
42$IPTABLES -A POSTROUTING -t nat -j MASQUERADE -s 192.168.7.0/24 104$IPTABLES -A POSTROUTING -t nat -j MASQUERADE -s 192.168.7.0/24